<?php
if( ! class_exists( 'audioComparisonStyling' ) ) {
    class audioComparisonStyling {
        public static function write_log($log) { AC_ACL_write_log('Audio Comparison Styling', $log); }
public $MAIN_DIV;
public $PREFIX;
public function __construct($main_div) {
    $this->MAIN_DIV = $main_div;
    $this->PREFIX = '.' . $main_div;
}
public function generate_css($Theme,$ColA,$ColB,$ColC,$Width,$Height,$Border,$Corner,$FontSize,$LabelColor,$LabelWidth) {
    $Themes = $this->get_theme_templates();
    $ContrastDefault = $Themes['ContrastDefault'];
    $LightenDarkenAmmount = $Themes['LightenDarkenAmmount'];
    $ContrastBias = $Themes[$Theme . '_defaults']['ContrastBias'];
    $Contrast = $ContrastDefault + $ContrastBias;
    $Lighter = $LightenDarkenAmmount;
    $Darker = -$LightenDarkenAmmount;
    $ContrastToA = self::ContrastTo($ColA, $Contrast);
    $ContrastToB = self::ContrastTo($ColB, $Contrast);
    $ContrastToC = self::ContrastTo($ColC, $Contrast);
    $HoverColA = self::LightenDarkenColor($ColA, self::Brightness($ColA) > $Contrast ? $Darker : $Lighter);
    $HoverColB = self::LightenDarkenColor($ColB, self::Brightness($ColB) > $Contrast ? $Darker : $Lighter);
    $HoverColC = self::LightenDarkenColor($ColC, self::Brightness($ColC) > $Contrast ? $Darker : $Lighter);
    $HoverContrastToA = self::LightenDarkenColor($ContrastToA, self::Brightness($ContrastToA) > $Contrast ? $Darker : $Lighter);
    $HoverContrastToB = self::LightenDarkenColor($ContrastToB, self::Brightness($ContrastToB) > $Contrast ? $Darker : $Lighter);
    $HoverContrastToC = self::LightenDarkenColor($ContrastToC, self::Brightness($ContrastToC) > $Contrast ? $Darker : $Lighter);
    $MixAandB = self::MixColors($ColA, $ColB);
    $ContrastToMixAandB = self::ContrastTo($MixAandB, $Contrast);
    $HoverMixAandB = self::LightenDarkenColor($MixAandB, self::Brightness($MixAandB) > $Contrast ? $Darker : $Lighter);
    $HoverContrastToMixAandB = self::LightenDarkenColor($ContrastToMixAandB, self::Brightness($ContrastToMixAandB) > $Contrast ? $Darker : $Lighter);
    $find =     [ '$HoverColA', '$HoverColB', '$HoverColC', '$HoverContrastToA', '$HoverContrastToB', '$HoverContrastToC', '$ColA', '$ColB', '$ColC', '$ContrastToA', '$ContrastToB', '$ContrastToC', '$MixAandB', '$ContrastToMixAandB', '$HoverMixAandB', '$HoverContrastToMixAandB', '$Width', '$Height', '$Border', '$Corner', '$FontSize', '$LabelColor', '$LabelWidth' ];
    $replace =  [  $HoverColA ,  $HoverColB ,  $HoverColC ,  $HoverContrastToA ,  $HoverContrastToB ,  $HoverContrastToC ,  $ColA ,  $ColB ,  $ColC ,  $ContrastToA ,  $ContrastToB ,  $ContrastToC ,  $MixAandB,   $ContrastToMixAandB,   $HoverMixAandB,   $HoverContrastToMixAandB,   $Width ,  $Height ,  $Border ,  $Corner ,  $FontSize ,  $LabelColor ,  $LabelWidth ];
    $style = str_replace($find, $replace, $Themes[$Theme]);
    return $style;
}
function LightenDarkenColor($col,$amt) {
    $rgb = self::RGBfrom($col);
    $r = $rgb[0] + $amt;
    if ( $r > 255 ) $r = 255;
    else if ($r < 0) $r = 0;
    $b = $rgb[2] + $amt;
    if ( $b > 255 ) $b = 255;
    else if  ($b < 0) $b = 0;
    $g = $rgb[1] + $amt;
    if ( $g > 255 ) $g = 255;
    else if  ( $g < 0 ) $g = 0;
    return self::ToRGB($col,$r,$g,$b);
}
public static function ContrastTo($col,$contrast) {
    $brightness = self::Brightness($col);
    $r = $b = $g = 0;
    if ($brightness <= $contrast) {
        $r = $g = $b = 255;
    }
    return self::ToRGB($col,$r,$g,$b);
}
public static function Brightness($col) {
    $rgb = self::RGBfrom($col);
    return round((($rgb[0] * 299) + ($rgb[1] * 587) + ($rgb[2] * 114)) / 1000);
}
public static function MixColors($a,$b) {
    $rgbA = self::RGBfrom($a);
    $rgbB = self::RGBfrom($b);
    return self::ToRGB($a,floor(($rgbA[0] + $rgbB[0])/2),floor(($rgbA[1] + $rgbB[1])/2),floor(($rgbA[2] + $rgbB[2])/2));
}
public static function RGBfrom($col) {
    if ( $col[0] == "#" ) {
        $col = substr($col, 1);
    }
    $num = hexdec($col);
    $r = ($num >> 16);
    $g = (($num >> 8) & 0x00FF);
    $b = ($num & 0x0000FF);
    return [ $r,$g,$b ];
}
public static function ToRGB($col,$r,$g,$b) {
    $s = '00000' . dechex($b | ($g << 8) | ($r << 16));
    return (( $col[0] == "#" )?"#":"") . substr($s, strlen($s) - 6);
}
public function get_theme_templates() {
    $PREFIX = $this->PREFIX;
    $MAIN_DIV = $this->MAIN_DIV;
    $imp = ' !important; ';
    return [
        'ContrastDefault' => '125',
        'LightenDarkenAmmount' => '18',
        'ac' =>
            $PREFIX . '-play-a,' . $PREFIX . '-play-b' .
            ',' . $PREFIX . '-play-c' .
            ',' . $PREFIX . '-play-stop { ' .
                'line-height: $Heightpx' . $imp .
                'min-width: $Widthpx' . $imp .
                'padding: 10px 0px 10px 0px' . $imp .
                'background-color: $ColC' . $imp .
                'font-size: $FontSizepx' . $imp .
                'font-weight: 700' . $imp .
                'border-radius: $Cornerpx' . $imp .
                'text-align: center' . $imp .
                'letter-spacing: normal' . $imp .
            '} ' .
            $PREFIX . '-play-stop { ' .
                'color: $ColB' . $imp .
                'border: $Borderpx solid $ColB' . $imp .
            '} ' .
            $PREFIX . '-play-a,' . $PREFIX . '-play-b' . 
            ',' . $PREFIX . '-play-c' .
            ' { ' .
                'color: $ColA' . $imp .
                'border: $Borderpx solid $ColA' . $imp .
            '} ' .
            $PREFIX . '-button-playing { ' .
                'color: $ColC' . $imp .
                'background-color: $ColA' . $imp .
            '} ' .
            $PREFIX . '-label { ' .
                'margin-left: 5px' . $imp .
                'color: $LabelColor' . $imp .
                'font-size: $FontSizepx' . $imp .
                'width: $LabelWidthpx' . $imp .
                'display: inline-block;' . 
            '} ' .
            $PREFIX . '-button-buffering { ' .
                'opacity: 0.3' . $imp .
                'cursor: not-allowed' . $imp .
            '} ' .
            $PREFIX . '-output-buffering { ' .
                'opacity: 0.5' . $imp .
            '} ',
        'ac_defaults'=> [
            'ColA'=> '#f0a07c',
            'ColB'=> '#4a274f',
            'ColC'=> '#ffffff',
            'Width'=> '140',
            'Height'=> '10',
            'Border'=> '2',
            'Corner'=> '0',
            'ContrastBias'=> '0',
            'FontSize' => '13',
            'LabelColor' => '#4a274f',
            'LabelWidth' => '121',
            'Name' => 'Audio Comparison',
            'Pro' => '0',
        ],
        'sk' =>
            $PREFIX . '-play-a,' . $PREFIX . '-play-b' .
            ',' . $PREFIX . '-play-c' .
            ',' . $PREFIX . '-play-stop { ' .
                'line-height: $Heightpx' . $imp .
                'min-width: $Widthpx' . $imp .
                'padding: 10px 0px 10px 0px' . $imp .
                'font-size: $FontSizepx' . $imp .
                'font-weight: 400' . $imp .
                'border-radius: $Cornerpx' . $imp .
                'text-align: center' . $imp .
                'letter-spacing: normal' . $imp .
            '} ' .
            $PREFIX . '-play-stop { ' .
                'color: $ColC' . $imp .
                'background-color: $ContrastToC' . $imp .
                'border: $Borderpx solid $ColC' . $imp .
            '} ' .
            $PREFIX . '-play-stop:hover { ' .
                'background-color: $HoverContrastToC' . $imp .
            '} ' .
            $PREFIX . '-play-a { ' .
                'color: $ContrastToA' . $imp .
                'background-color: $ColA' . $imp .
                'border: $Borderpx solid $ColB' . $imp .
            '} ' .
            $PREFIX . '-play-a:hover { ' .
                'background-color: $HoverColA' . $imp .
            '} ' .
            $PREFIX . '-play-b { ' .
                'color: $ContrastToB' . $imp .
                'background-color: $ColB' . $imp .
                'border: $Borderpx solid $ColA' . $imp .
            '} ' .
            $PREFIX . '-play-b:hover { ' .
                'background-color: $HoverColB' . $imp .
            '} ' .
            $PREFIX . '-play-c { ' .
                'color: $ContrastToMixAandB' . $imp .
                'background-color: $MixAandB' . $imp .
                'border: $Borderpx solid $MixAandB' . $imp .
            '} ' .
            $PREFIX . '-play-c:hover { ' .
                'background-color: $HoverMixAandB' . $imp .
            '} ' .
            $PREFIX . '-button-playing { ' .
                'animation: ' . $MAIN_DIV . '_blinker 1.2s linear infinite; ' .
            '} ' .
            $PREFIX . '-label { ' .
                'margin-left: 6px; ' .
                'color: $LabelColor; '.
                'font-size: $FontSizepx; ' .
                'width: $LabelWidthpx' . $imp .
                'display: inline-block;' . 
            '} ' .
            $PREFIX . '-button-buffering { ' .
                'opacity: 0.3; ' .
                'cursor: not-allowed; ' .
            '} ' .
            $PREFIX . '-output-buffering { ' .
                'animation: ' . $MAIN_DIV . '_blinker 1.2s linear infinite; ' .
            '} ' .
            '@keyframes ' . $MAIN_DIV . '_blinker { ' .
                '50% { ' .
                    'opacity: .5; ' .
                '} ' .
            '} ',
        'sk_defaults'=> [
            'ColA'=> '#828282',
            'ColB'=> '#e96656',
            'ColC'=> '#000000',
            'Width'=> '150',
            'Height'=> '25',
            'Border'=> '0',
            'Corner'=> '7',
            'ContrastBias'=> '15',
            'FontSize' => '14',
            'LabelColor' => '#000000',
            'LabelWidth' => '101',
            'Name' => 'studio kaedinger',
            'Pro' => '0',
        ],
        'ss' =>
            $PREFIX . '-play-a,' . $PREFIX . '-play-b' .
            ',' . $PREFIX . '-play-c' .
            ',' . $PREFIX . '-play-stop { ' .
                'line-height: $Heightpx' . $imp .
                'min-width: $Widthpx' . $imp .
                'padding: 10px 0px 10px 0px' . $imp .
                'background-color: transparent' . $imp .
                'font-size: $FontSizepx' . $imp .
                'font-weight: 700' . $imp .
                'border-radius: $Cornerpx' . $imp .
                'text-align: center' . $imp .
                'letter-spacing: normal' . $imp .
                'transition: 1s' . $imp .
            '} ' .
            $PREFIX . '-play-stop { ' .
                'color: $ColC' . $imp .
                'border: $Borderpx solid $ColC' . $imp .
            '} ' .
            $PREFIX . '-play-a,' . $PREFIX . '-play-b' . 
            ',' . $PREFIX . '-play-c' .
            ' { ' .
                'color: $ColA' . $imp .
                'border: $Borderpx solid $ColA' . $imp .
            '} ' .
            $PREFIX . '-play-stop:hover, ' . $PREFIX . '-playing { ' .
                'border-color: transparent' . $imp .
                'color: $ContrastToC' . $imp .
                'background-color: $ColC' . $imp .
            '} ' .
            $PREFIX . '-play-a:hover,' . $PREFIX . '-play-b:hover' . 
            ',' . $PREFIX . '-play-c:hover' .
            ',' . $PREFIX . '-button-playing' .
            ' { ' .
                'border-color: transparent' . $imp .
                'color: $ContrastToB' . $imp .
                'background-color: $ColB' . $imp .
            '} ' .
            $PREFIX . '-label { ' .
                'margin-left: 10px' . $imp .
                'color: $LabelColor' . $imp .
                'font-size: $FontSizepx' . $imp .
                'width: $LabelWidthpx' . $imp .
                'display: inline-block;' . 
            '} ' .
            $PREFIX . '-button-buffering { ' .
                'opacity: 0.3' . $imp .
                'cursor: not-allowed' . $imp .
            '} ' .
            $PREFIX . '-output-buffering { ' .
                'opacity: 0.5' . $imp .
            '} ' .
            $PREFIX . '-output-playing-a,' . $PREFIX . '-output-playing-b' .
            ',' . $PREFIX . '-output-playing-c' .
            ' { ' .
                'animation: ' . $MAIN_DIV . '_colorize 1s linear infinite; ' .
            '} ' .
            '@keyframes ' . $MAIN_DIV . '_colorize { ' .
                '50% { ' .
                    'color: $ColB; ' .
                '} ' .
            '} ',
        'ss_defaults'=> [
            'ColA'=> '#98b6d2',
            'ColB'=> '#5d96cb',
            'ColC'=> '#e6c937',
            'Width'=> '105',
            'Height'=> '79',
            'Border'=> '2',
            'Corner'=> '50',
            'ContrastBias'=> '15',
            'FontSize' => '17',
            'LabelColor' => '#376590',
            'LabelWidth' => '135',
            'Name' => 'Sunny Sky',
            'Pro' => '1',
        ],
        'ep' =>
            $PREFIX . '-play-a,' . $PREFIX . '-play-b' .
            ',' . $PREFIX . '-play-c' .
            ',' . $PREFIX . '-play-stop { ' .
                'line-height: $Heightpx' . $imp .
                'min-width: $Widthpx' . $imp .
                'padding: 10px 0px 10px 0px' . $imp .
                'background-color: transparent' . $imp .
                'font-size: $FontSizepx' . $imp .
                'font-weight: 700' . $imp .
                'border-radius: $Cornerpx' . $imp .
                'transition: 0.5s' . $imp .
                'text-align: center' . $imp .
                'letter-spacing: normal' . $imp .
            '} ' .
            $PREFIX . '-play-stop { ' .
                'color: $ColC' . $imp .
                'border: $Borderpx solid $ColC' . $imp .
            '} ' .
            $PREFIX . '-play-stop:hover { ' .
                'color: $ContrastToC' . $imp .
                'background-color: $ColC' . $imp .
            '} ' .
            $PREFIX . '-play-a { ' .
                'color: $ColA' . $imp .
                'border: $Borderpx solid $ColA' . $imp .
            '} ' .
            $PREFIX . '-play-a:hover { ' .
                'color: $ContrastToA' . $imp .
                'background-color: $ColA' . $imp .
            '} ' .
            $PREFIX . '-play-b { ' .
                'color: $ColB' . $imp .
                'border: $Borderpx solid $ColB' . $imp .
            '} ' .
            $PREFIX . '-play-b:hover { ' .
                'color: $ContrastToB' . $imp .
                'background-color: $ColB' . $imp .
            '} ' .
            $PREFIX . '-play-c { ' .
                'color: $MixAandB' . $imp .
                'border: $Borderpx solid $MixAandB' . $imp .
            '} ' .
            $PREFIX . '-play-c:hover { ' .
                'color: $ContrastToMixAandB' . $imp .
                'background-color: $MixAandB' . $imp .
            '} ' .
            $PREFIX . '-button-playing,' . $PREFIX . '-playing { ' .
                'border-radius: max(calc($Heightpx / 2), calc($Widthpx / 2))' . $imp .
            '} ' .
            $PREFIX . '-button-buffering { ' .
                'opacity: 0.3' . $imp .
            '} ' .
            $PREFIX . '-label { ' .
                'margin-left: 10px' . $imp .
                'color: transparent' . $imp .
                'font-size: $FontSizepx' . $imp .
                'font-weight: 700' . $imp .            
                'width: $LabelWidthpx' . $imp .
                'transition: 0.5s' . $imp .
                'display: inline-block; ' . 
            '} ' .
            $PREFIX . '-output-buffering { ' .
                'color: $LabelColor' . $imp .
                'opacity: 0.5' . $imp .
            '} ' .
            $PREFIX . '-output-playing-a,' . $PREFIX . '-output-playing-b' .
            ',' . $PREFIX . '-output-playing-c' .
            ' { ' .
                'color: $LabelColor' . $imp .
            '} ',
        'ep_defaults'=> [
            'ColA'=> '#9f956c',
            'ColB'=> '#cbbf7a',
            'ColC'=> '#577590',
            'Width'=> '106',
            'Height'=> '80',
            'Border'=> '1',
            'Corner'=> '10',
            'ContrastBias'=> '15',
            'FontSize' => '13',
            'LabelColor' => '#577590',
            'LabelWidth' => '135',
            'Name' => 'Elegant Play',
            'Pro' => '1',
        ],
    ];
}
}}